;*******************************************************************
w	equ	0		;parametr instrukci
f	equ	1		;parametr instrukci
f0	equ	0x00		;registr neprimeho adresovani
status	equ	0x03		;status je na adrese 0x03
fsr	equ	0x04		;registr adresy neprimeho adresovani
porta	equ	0x05
trisa	equ	0x85		;pouzijeme neprime adresovani
cnt1	equ	0x0C		;definice registru cnt1
cnt2	equ	0x0D		;definice registru cnt2
cnt3	equ	0x0E
;*******************************************************************
#define LED	porta,4		;LED je pinu RA4
;*******************************************************************
	list 	p = 16F84
	__config 0x3FF1		;nastaveni konfigurace
;*******************************************************************
	org	0x0000		;adresa zacatku programu
	goto	Main		;skoci na zacatek hlavniho programu
;*******************************************************************
Cekej	movlw	D'250'
	movwf	cnt3		;naplneni registru 3.smycky
Cekej_A	movlw	D'100'
	movwf	cnt2		;naplneni registru 2.smycky
Cekej_B	movlw	D'10'
	movwf	cnt1		;naplneni registru 1.smycky
Cekej_C	decfsz	cnt1,f		;odecte od registru 1.smycky 1
	goto	Cekej_C		;skoci, je-li registr roven 0
	decfsz	cnt2,f		;odecte od registru 2.smycky 1
	goto	Cekej_B		;skoci, je-li registr roven 0
	decfsz	cnt3,f		;odecte od registru 3.smycky 1
	goto	Cekej_A		;skoci, je-li registr roven 0
	return			;navrat do hlavniho programu
;********************************************************************
Main	movlw	trisa				
	movwf	fsr		;registr trisa bude neprimo adresovan
	movlw	B'11101111'
	movwf	f0		;zapis do registru trisa
Main_A	bcf	LED		;rozsviti LED
	call	Cekej		;zavola podprogram s cekaci smyckou
	bsf	LED		;zhasne LED
	call	Cekej		;zavola podprogram s cekaci smyckou
	goto	Main_A		;skoci na zacatek smycky
	end
