;***********************************************************************
w       equ     0               ;parametr instrukci
f       equ     1               ;parametr instrukci
tmr0    equ     0x01
optreg  equ     0x01            ;pouzijeme prime adresovani
pcl     equ     0x02
status  equ     0x03            ;swr je na adrese 0x03
porta   equ     0x05
trisa   equ     0x05            ;pouzijeme prime adresovani
portb   equ     0x06
trisb   equ     0x06            ;pouzijeme prime adresovani
intcon  equ     0x0B
disp    equ     0x0C            ;pamet znaku
;***********************************************************************
#define RP0     status,5
#define T0IF    intcon,2        ;indikace preteceni tmr0
;***********************************************************************
	list    p = 16F84
	__config 0x3FF1         ;nastaveni konfigurace
;***********************************************************************
	org     0x0000
	goto    Main
;***********************************************************************
Cekej   bcf     T0IF            ;vynulovani bitu T0IF
	clrf    tmr0            ;vynulovani tmr0 a preddelicky
Cekej_A btfss   T0IF            ;testovani preteceni tmr0
	goto    Cekej_A         ;nepretekl-li tmr0, testuje znovu
	bcf     T0IF            ;vynulovani bitu T0IF
	return
;***********************************************************************
Tabulka addwf   pcl,f           ;pricte W k citaci instrukci
	retlw   B'11000000'     ; zobrazi 0
	retlw   B'11111001'     ; zobrazi 1
	retlw   B'10100100'     ; zobrazi 2
	retlw   B'10110000'     ; zobrazi 3
	retlw   B'10011001'     ; zobrazi 4
	retlw   B'10010010'     ; zobrazi 5
	retlw   B'10000010'     ; zobrazi 6
	retlw   B'11111000'     ; zobrazi 7
	retlw   B'10000000'     ; zobrazi 8
	retlw   B'10010000'     ; zobrazi 9
;***********************************************************************
Main    bsf     RP0             ;stranka 1 pameti RAM
	movlw   B'11010111'
	movwf   optreg          ;konfigurace tmr0 a preddelicky
	bcf     RP0             ;stranka 0 pameti RAM
;***********************************************************************
Main_A  bsf     RP0             ;stranka 1 pameti RAM
	movlw   0xFF 
	movwf   portb           ;port B je vstupni
	movlw   0xFF            ;port A je vstupni
	movwf   porta
	bcf     RP0             ;stranka 0 pameti RAM
	movlw   0x01
	call    Tabulka         ;zakoduje 1 jako znak 1
	btfss   portb,0
	goto    Main_B          ;je-li tlacitko sepnuto, tak zobraz 1
	movlw   0x02
	call    Tabulka         ;zakoduje 2 jako znak 2
	btfss   portb,1
	goto    Main_B          ;je-li tlacitko sepnuto, tak zobraz 2
	movlw   0x03
	call    Tabulka         ;zakoduje 3 jako znak 3
	btfss   portb,2
	goto    Main_B          ;je-li tlacitko sepnuto, tak zobraz 3
	movlw   0x04
	call    Tabulka         ;zakoduje 4 jako znak 4
	btfss   portb,3
	goto    Main_B          ;je-li tlacitko sepnuto, tak zobraz 4
	movlw   0x05
	call    Tabulka         ;zakoduje 5 jako znak 5
	btfss   portb,4
	goto    Main_B          ;je-li tlacitko sepnuto, tak zobraz 5
	movlw   0x06
	call    Tabulka         ;zakoduje 6 jako znak 6
	btfss   portb,5
	goto    Main_B          ;je-li tlacitko sepnuto, tak zobraz 6
	movlw   0x07
	call    Tabulka         ;zakoduje 7 jako znak 7
	btfss   portb,6
	goto    Main_B          ;je-li tlacitko sepnuto, tak zobraz 7
	movlw   0x08
	call    Tabulka         ;zakoduje 8 jako znak 8
	btfss   portb,7
	goto    Main_B          ;je-li tlacitko sepnuto, tak zobraz 8
	goto    Main_A          ;neni-li stisknuto nic, skoci na zacatek
Main_B  movwf   portb           ;zapise znak na portb
	bsf     RP0             ;stranka 1 pameti RAM
	movlw   0x00 
	movwf   portb           ;port B je vystupni
	movlw   B'11111110'     ;aktivuje 1. sedmisegmentovku
	movwf   porta
	bcf     RP0             ;stranka 0 pameti RAM
	bcf     porta,0         ;rozsviti prvni sedmisegmentovku
	call    Cekej 
	goto    Main_A          ;skoci na zacatek
	end







