;****************************************************************
status	equ	0x03		;status je na adrese 0x03
porta	equ	0x05
trisa	equ	0x05		;pouzijeme prime adresovani
portb	equ	0x06
trisb	equ	0x06		;pouzijeme prime adresovani
;****************************************************************
#define TL	portb,0		;tlacitko na pinu RB0
#define LED	porta,4		;LED je na pinu RA4
#define	RP0	status,5	;RP0 je 5.bit registru status
;****************************************************************
	list 	p = 16F84
	__config 0x3FF1		;nastaveni konfigurace
;****************************************************************	
	org	0x0000		;program je ulozen od adresy 0x00
	bsf	RP0		;stranka 1 pamti RAM
	movlw	B'11101111'	
	movwf	trisa		;pin RA4 je vystup
	movlw	B'11111111' 
	movwf	trisb		;piny portu RB jsou vstupy
	bcf	RP0		;stranka 0 pameti RAM
Main	btfss	TL		;je TL 0 nebo 1?
	goto	Main_A		;je-li TL 0, skoc na Main_A
	bsf	LED		;TL je 1, zhasne LED
	goto	Main		;uzavira smycku
Main_A	bcf	LED		;rozsviti LED
	goto	Main		;uzavira smycku
	end			;konec programu
 	
